/***
 * Excerpted from "Modern Systems Programming with Scala Native",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/rwscala for more book information.
***/
import scala.scalanative.unsafe._
import scala.scalanative.libc._

object main {

  def main(args:Array[String]):Unit = {
    var max_word:Ptr[Byte] = stackalloc[Byte](1024)
    val max_count = stackalloc[Int]
    val max_year = stackalloc[Int]

    val line_buffer = stackalloc[Byte](1024)
    val temp_word = stackalloc[Byte](1024)
    val temp_count = stackalloc[Int]
    val temp_year = stackalloc[Int]
    val temp_doc_count = stackalloc[Int]

    var lines_read = 0
    !max_count = 0
    !max_year = 0

    while (stdio.fgets(line_buffer, 1024, stdio.stdin) != null) {
      lines_read += 1
      parse_and_compare(line_buffer, max_word, temp_word, 1024,
      max_count, temp_count, max_year, temp_year, temp_doc_count)
    }

    stdio.printf(c"done. read %d lines\n", lines_read)
    stdio.printf(c"maximum word count: %d for '%s' @ %d\n", !max_count,
     max_word, !max_year)
  }

  def parse_and_compare(line_buffer:CString, max_word:CString,
                    temp_word:CString, max_word_buffer_size:Int,
                    max_count:Ptr[Int], temp_count:Ptr[Int], max_year:Ptr[Int],
                    temp_year:Ptr[Int], temp_doc_count:Ptr[Int]):Unit = {
    val scan_result = stdio.sscanf(line_buffer, c"%1023s %d %d %d\n",
         temp_word, temp_year, temp_count, temp_doc_count)
    if (scan_result < 4) {
      throw new Exception("bad input")
    }
    if (!temp_count <= !max_count) {
      return
    } else {
      stdio.printf(c"saw new max: %s %d occurences at year %d\n", temp_word,
        !temp_count, !temp_year)
      val word_length = string.strlen(temp_word)
      if (word_length >= (max_word_buffer_size - 1)) {
        throw new Exception(
          s"length $word_length exceeded buffer size $max_word_buffer_size")
      }
      string.strncpy(max_word, temp_word, max_word_buffer_size)
      !max_count = !temp_count
      !max_year = !temp_year
    }
  }
}
